<?php
	include_once("atomconfig.php");
	include_once("atomdoc.php");
	include_once("atomfunc.php");

	include_once("template/class.TemplatePower.inc.php");


	$req = new Request();
	#print "\n\n";

		#debug();

	switch($req->method) {
		case "GET":
			doGet();
			break;
		case "POST":
			doPost();
			break;
		case "PUT":
			doPut();
			break;
		case "DELETE":
			doDelete();
			break;
	}
	
	
	function debug() {
		global $req;
		echo "<ul>\n";
		echo "<li>blogName: " . $req->blogName . "</li>\n";
		echo "<li>blogEntry: " . $req->blogEntry . "</li>\n";
		echo "<li>blogComment: " . $req->blogComment . "</li>\n";
		echo "<li>method: " . $req->method . "</li>\n";
		echo "</ul>\n\n";

		$i = 0;
		foreach ($req->atomDoc->entries as $entry) {
			$i++;
			echo "Entry $i\n";
			echo "\tTitle :  " . $entry->title . "\n";
			echo "\tAuthor:  " . $entry->author->name . "\n";
			echo "\tLink:  " . $entry->link . "\n";
			echo "\tContent-Type:  " . $entry->content[0]->type . "\n";
			echo "\tContent: " . $entry->content[0]->text . "\n\n";
		}

		#print dateW3DateToSql("2003-07-22T07:11-05:00");
	}
	

	//phpinfo();

	// do{HttpMethod} functions
	function doGet() {
		global $req;
		if ($req->blogComment) {
			# Comment requested
			print "Getting a comment\n\n";		
		} elseif ($req->blogEntry) {
			# Blog Entry requested
			#print "Getting a Blog Entry\n\n";
			getBlogEntry();
		} elseif ($req->blogName) {
			# Blog requested
			#print "Getting a Blog\n\n";
			getCurrentBlogEntries();
		} else {
			# Invalid Post Method
			print "Invalid Get method\n\n";
		}
	
	}
	
	function doPost() {
		global $req;
		if ($req->blogEntry) {
			# New Comment posted
			print "Posting a new comment\n\n";
		} elseif ($req->blogName) {
			# New Blog entry posted
			#print "Posting a new blog entry\n\n";
			#debug();
			addNewBlogEntry();
		} else {
			# Invalid Post Method
			print "Invalid Post method\n\n";
		}
	}
	
	function doPut() {
		global $req;
		if ($req->blogComment) {
			# Updating a Comment
			print "Updating a comment\n\n";
		} elseif ($req->blogEntry) {
			# Updating a Blog Entry
			#print "Updating a Blog Entry\n\n";
			updateBlogEntry();
		} else {
			# Invalid Put Method
			print "Invalid Put Method\n\n";
		}
	}
	
	function doDelete() {
		global $req;
		if ($req->blogComment) {
			# Delete a comment
			print "Deleting a comment\n\n";
		} elseif ($req->blogEntry) {
			# Delete a Blog Entry
			#print "Deleting a blog entry\n\n";
			deleteBlogEntry();
		} else {
			# Invalid Delete Method
			print "Invalid Delete method\n\n";
		}
	}



	// Encapsulate the request
	class Request {
		var $rootUri = "/atomblog/";
		var $pageUri;
		var $xmlstring;
		var $method;

		var $blogName;
		var $blogEntry;
		var $blogComment;
		
		var $atomDoc;

		
		function Request() {
			global $_SERVER;

			$this->splitRequestUri(strip_tags($_SERVER["REQUEST_URI"]));
			$this->method=$_SERVER["REQUEST_METHOD"];
			if ($this->method=="POST" || $this->method=="PUT") {
				$this->xmlstring = file_get_contents("php://input");
				if ($this->xmlstring) {
					$this->atomDoc = new AtomDoc($this->xmlstring);
				}
			}
		
		}
		
		function splitRequestUri($reqUrl) {
			global $rootUri;
			
			// Kill the query string
			$newVar = explode("?", $reqUrl);
			$reqUrl = $newVar[0];

			// Split Request into array elements for processing
			if ($reqUrl=="/atomblog") { $reqUrl="/atomblog/"; }
			$requestArray = array();
			$tmpArray =  explode("/", $reqUrl);
			array_shift($tmpArray);
			#array_shift($tmpArray);
			$this->pageUri = $rootUri;

			if ($tmpArray) {
				foreach ($tmpArray as $key) {
					if ($this->blogName) {
						if ($this->blogEntry) {
							if ($this->blogComment) {
								// Now what?
								// must be more than three levels deep
								// so lets ignore it
							} else {
								##$this->blogComment = $key;
								##$this->pageUri .= $key . "/";
							}	
						} else {
							$this->blogEntry = $key;
							$this->pageUri .= $key . "/";
						}
					} else {
						$this->blogName = $key;								
						$this->pageUri .= $key . "/";
					}
				}
			}
		}
		
	}

?>